<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc01300MovimentacaoFinanceiraFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getAgencias ($params) {
        $sql = "SELECT DISTINCT CDAGENCIA
                FROM AGENCIA
                WHERE CDBANCO = :CDBANCO
                  AND NRORG = :NRORG
                  ORDER BY CDAGENCIA";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getContas ($params) {
        $sql = "SELECT DISTINCT CDCONTCORR 
                FROM CONTCORR
                WHERE CDBANCO = :CDBANCO
                  AND CDAGENCIA = :CDAGENCIA
                  AND NRORG = :NRORG
                ORDER BY CDCONTCORR";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getBancoMasks ($params) {
        $sql = "SELECT CDPICTAGEN, CDPICTCONT
                  FROM BANCO
                 WHERE CDBANCO = :CDBANCO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
   public function movimentacaoFinanceiraFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProductsOn($params){
        $sql= "SELECT DAT.NRPRODUTOADQ, DAT.NMPRODUTOADQ, DAT.CDPRODUTOADQ||' - '||DAT.NMPRODUTOADQ AS LABELPRODUTOADQ, 
                 N FROM 
               (SELECT D.*, ROWNUM as N 
                FROM 
                     (SELECT NRPRODUTOADQ, NMPRODUTOADQ, CDPRODUTOADQ, CDPRODUTOADQ||' - '||NMPRODUTOADQ AS LABELPRODUTOADQ,
                      NRORG
                       FROM PRODUTOADQ 
                       WHERE UPPER (CDPRODUTOADQ||' - '||NMPRODUTOADQ) LIKE UPPER ('%'||:LABELPRODUTOADQ||'%')
                        AND IDATIVO = 'S'
                        AND IDUTILIZADO = 'S'
                       ) D ) DAT
            ORDER BY LABELPRODUTOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}