<?php
/**
 * Created by PhpStorm.
 * User: viniciusresende
 * Date: 11/01/2023
 * Time: 12:28
 */
set_time_limit(43200);
ini_set('memory_limit', '1G');
// Arquivo com as buscas de vendas e pagamentos Equals
include('EQUALS_API.php');

class Cnc_Equals {
    
    private static $responseVenda     = [];
    private static $responsePagamento = [];
    private static $nrSeqControle = '';
    private static $accessDate;
    private static $responseDate;
    private static $nrorg;
    private static $estabelec = [];
    private static $periodIni;
    private static $periodEnd;
    private static $connProc;
    private static $Aplicativo;
    private static $rowBackCount = 0;
    
    private function __construct () {
        self::$responsePagamento = $GLOBALS['responsePagamento'];
        self::$responseVenda     = $GLOBALS['responseVenda'];
        self::$accessDate        = $GLOBALS['accessDate'];
        self::$nrorg             = $GLOBALS['nrorg'];
        self::$responseDate      = $GLOBALS['responseDate'];
        self::$nrSeqControle     = $GLOBALS['nrSeqControle'];
        self::$connProc          = $GLOBALS['connProc'];
        self::$estabelec         = $GLOBALS['estabelec'];
        self::$Aplicativo        = 0;
    }
    
    /*
     * Estabele conexão com o serviço SOAP da VAN e faz duas requisições: uma para o relatório de vendas e outra o
     * relatório de pagamentos.
    */
    public static function executeWSEquals () {
        try {
            $params = isset($_POST['NRORG']) ? $_POST['NRORG'] : null;
            //echo 'Nrorg:'.$params;
            // Define a data em que o WS foi acessado
            date_default_timezone_set("America/Sao_Paulo");
            self::$accessDate = date('d/m/Y H:i:s');
            
            self::$periodIni = date('d/m/Y',strtotime("-10 days"));
	        self::$periodEnd = date('d/m/Y',strtotime("+0 days"));
	        
	       //self::$periodIni = date('d/m/Y',strtotime("03/04/2024"));
	       //self::$periodEnd = date('d/m/Y',strtotime("03/04/2024"));
	        
	        echo 'Data inicial'.self::$periodIni.'\n';
	        echo 'Data final'.self::$periodEnd.'\n';
            
            $conn = Cnc_Equals::openConnectionOnDB($params);
            
            // Define o NRORG que será utilizado em toda a execução do WS
            $sql = "select nvl(decode(SYS_CONTEXT('nrorg_ctx', 'nrorg'), 0, 1, SYS_CONTEXT('nrorg_ctx', 'nrorg')), 1) NRORG from dual";
            $statement = oci_parse($conn, $sql);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            self::$nrorg = oci_fetch_assoc($statement)['NRORG'];
            oci_free_statement($statement);
            oci_close($conn);
        
            if (!self::$nrorg) {
                throw new \Exception("Não foi possível obter o NRORG");
            }
            
            echo 'Nrorg sys_context:'.self::$nrorg;
            
            // Configuração das opções de proxy. Este trecho é opcional, uma vez que não necessariamente a conexão terá um
            // proxy
            $options = [
                'proxy_host' => PROXY_HOST,
                'proxy_port' => PROXY_PORT,
                'proxy_login' => PROXY_LOGIN,
                'proxy_password' => PROXY_PASSWORD,
                'keep_alive' => true,
                'stream_context' => stream_context_create(array(
                    'ssl' => array(
                        'verify_peer' => false,
                        'verify_peer_name' => false,
                        'allow_self_signed' => true
                    )
                ))
            ];
            
            // Verifica se a base em questão já possuí dados replicados. No caso dessa ser a primeira execução do WS, o período que
            // será utilizado são os 12 últimos dias para fazer o preenchimento inicial da base de produção.
            if(Cnc_Equals::CheckRetvenda(Cnc_Equals::openConnectionOnDB(self::$nrorg)) == 0){
                self::$periodIni = date('d/m/Y',strtotime("-8 days"));
                self::$periodEnd = date('d/m/Y',strtotime("-1 days"));
                $primeiroInsert = true;
            } else {
                $primeiroInsert = false;
            }
            
            // TEMP SOLUTION, quebra por pipe os id e senhas de acesso para os estabelecimentos do cliente
            $conn = Cnc_Equals::openConnectionOnDB(self::$nrorg);
            //$sql = "SELECT LISTAGG(IDEMPRESACNC||'|') WITHIN GROUP (ORDER BY NRORG) AS TOKENEMPRESA, LISTAGG(DSSENHACNC||'|') WITHIN GROUP (ORDER BY NRORG) AS TOKENSENHA, NRORG FROM TOKENCNC GROUP BY NRORG";
            $sql = "SELECT LISTAGG(IDEMPRESACNC||'|') WITHIN GROUP (ORDER BY IDEMPRESACNC) AS TOKENEMPRESA, LISTAGG(DSSENHACNC||'|') WITHIN GROUP (ORDER BY IDEMPRESACNC) AS TOKENSENHA, NRORG FROM TOKENCNC GROUP BY NRORG";
            $statement = oci_parse($conn, $sql);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            $tokenSenha = oci_fetch_assoc($statement);
            
            $idsEmpresaConc = explode("|", $tokenSenha['TOKENEMPRESA']);
            $passwords = explode("|", $tokenSenha['TOKENSENHA']);
            // Array pop utilizado para limpar a ultima posição do array que sempre vira como vazia.
            array_pop($idsEmpresaConc);
            array_pop($passwords);
            Cnc_Equals::ResolveSpecCarac($conn);
            oci_free_statement($statement);
            oci_close($conn);
            foreach ($idsEmpresaConc as $key=>$empresa) {
                echo 'Key Empresa'.$idsEmpresaConc[$key];
                echo 'Key Token'.$passwords[$key]."\n";
            }
            
            /*$idsEmpresaConc = explode("|", ID_EMPRESA_CONC);
            $passwords = explode("|", SENHA_CONC);*/
            
            // Merja os arrays em uma única e estrutura e cria um objeto com as propriedades idEmpresa e pass. Seria possível utilizar o
            // array accessInfo diretamente para o loop, ou mesmo usar os arrays idsEmpresaConc e passwords visto que eles sempre 
            // teriam o mesmo tamanho. Porém, essa opção foi escolhida para mais legibilidade e fácil substituição por um método mais 
            // eficiente em um futuro próximo.
            $accessInfo = Cnc_Equals::zipTwo($idsEmpresaConc, $passwords);
            $connParams = array_map(function($data) {
                return new AccessInfoInterface($data['COMPANY'], $data['PASSWORD']);
            }, $accessInfo);
            
            // Executa as operações de consulta e inserção do WS para cada um dos estabelecimentos informados.
            foreach($connParams as $connParam) {
                //Monta a chave de acesso concatenando "e-mail:token".
                $token = strval(base64_encode($connParam->getIdEmpresa().":".$connParam->getPass()));
                EqualsApi::setToken($token);
                
                $setParams = [
                    'idEmpresa' => $connParam->getIdEmpresa(),
                    'senha' =>  $connParam->getPass(),
                    'dataVendaInicial' => self::$periodIni,
                    'dataVendaFinal' => self::$periodEnd
                ];
                
                if($primeiroInsert) {
                    $dataInicial = date('d/m/Y',strtotime("-8 days"));
                    $dataInicialVend = date('Y-m-d',strtotime("-8 days"));
                    
	                $dataFinal = date('d/m/Y',strtotime("-1 days"));
	                $dataFinalVend = date('Y-m-d',strtotime("-1 days"));
                } else {
                    $dataInicial = date('d/m/Y',strtotime("-5 days"));
                    $dataInicialVend = date('Y-m-d',strtotime("-5 days"));
                    
	                $dataFinal = date('d/m/Y',strtotime("-1 days"));
	                $dataFinalVend = date('Y-m-d',strtotime("-1 days"));
                }
                
                // Busca as vendas através da API Equals
                $responseVenda = EqualsApi::getSalesFromPeriod($dataInicialVend, $dataFinalVend);
                
                $responseVenda = json_decode(json_encode($responseVenda), true);
                
                if (!$responseVenda) {
                    throw new \Exception("Não há dados de vendas para os parâmetros filtrados");
                }
                
                //Tratativas a partir dos dados de Venda recebidos
                
                // Verificar se e array antes de entrar
                if (is_array($responseVenda)) {
                    if (count($responseVenda) == 0) {
                        echo("Não houve retorno de vendas para a chave ".$setParams["idEmpresa"]." neste dia\n");
                    }
                }else {
                    echo("Não houve retorno de vendas para a chave ".$setParams["idEmpresa"]." neste dia\n");
                }
           
                // Define o date em que a resposta do WS foi recebida
                self::$responseDate = date('d/m/Y H:i:s');
                
                
                // Persistir o acesso para o relatório de vendas
                $conn = Cnc_Equals::openConnectionOnDB(self::$nrorg);
                Cnc_Equals::session($conn);
                Cnc_Equals::RegisterWSAccess($conn, 'V');
                
                $boolInsert = true;
                /*
                // Persistir o relatório de vendas.
                $bool = empty($responseVenda) ? true : Cnc_Equals::InsertSales($conn, $responseVenda);
                $bool ? var_dump('O relatório de Vendas foi inserido com sucesso.') : var_dump('Ocorreu um erro ao tentar inserir o relatório de Vendas.');
                $bool = empty(self::$nrSeqControle) ? true : Cnc_Equals::replicaDadosProc($conn, $boolInsert);
                $bool ? var_dump('A replicação de vendas foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar aplicar a replicação de Vendas.');
                */
                //Busca Id de Movimentação Financeira enviado pela Equals
                $idEmpresa = $connParam->getIdEmpresa();
                
                $sql = 'SELECT IDMOVFINANCEQ FROM TOKENCNC WHERE IDEMPRESACNC = :IDEMPRESACNC';
                $statement = oci_parse($conn, $sql);
                oci_bind_by_name($statement, ":IDEMPRESACNC", $idEmpresa);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $idMovFinanCfg = oci_fetch_assoc($statement)['IDMOVFINANCEQ'];
                
                // Busca o id do relatório de pagamentos através da API Equals
                $responseId = EqualsApi::getPaymentsFromPeriod($idMovFinanCfg, $dataInicial, $dataFinal);
                
                // Busca as informações do relatório de pagamentos através da API Equals
                $isConcluded = false;
                $count = 50;

                while (!$isConcluded && $count > 0) {
                    $responseInfos = EqualsApi::getPaymentsFromPeriodId($responseId->id);
                    $isConcluded = $responseInfos->situacao == 'CONCLUIDO';
                    if (!$isConcluded) {
                        sleep(1);
                    }
                    $count--;
                }
                
                $paginas = $responseInfos->quantidadePaginas;
                $i = 1;
                while($i <= $paginas) {
                    $responsePagamento = EqualsApi::getPaymentsFromPeriodAll($responseInfos->id, $i);
                    $i++;
                }
                
                //Tratativas a partir dos dados de Pagamento recebidos.

                // Verificar se é array antes de entrar
                if (is_array(self::$responsePagamento)) {
                    if (count(self::$responsePagamento) == 0) {
                        echo("Não houve retorno de pagamentos para a filial ".$setParams["idEmpresa"]." neste dia\n");
                        $boolInsert = false;
                    }
                }else {
                    echo("Não houve retorno de pagamentos para a filial ".$setParams["idEmpresa"]." neste dia\n");
                    $boolInsert = false;
                }
                
                self::$responseDate = date('d/m/Y H:i:s');
                Cnc_Equals::RegisterWSAccess($conn, 'P');
                $bool = empty(self::$responsePagamento) ? true : Cnc_Equals::InsertPayments($conn, self::$responsePagamento);
                $bool ? var_dump('O relatório de Pagamentos foi inserido com sucesso.') : var_dump('Ocorreu um erro ao tentar inserir o relatório de Pagamentos.');
                $bool = empty(self::$nrSeqControle) ? true : Cnc_Equals::replicaDadosProc($conn, $boolInsert);
                $bool ? var_dump('A replicação do Financeiro foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar aplicar a replicação o Financeiro.');
                
                $clientVenda             = null;
                $clientPagto             = null;
                $setParams               = null;
                $paramsPagamentos        = null;
                self::$responseVenda     = [];
                self::$responsePagamento = [];
            }
            self::$connProc = $conn;
            $estabelecimentos = array_map(function($estabelec) {
                return  Cnc_Equals::getNrEstabelec(self::$connProc, $estabelec);
            }, self::$estabelec);
            
            
            if (is_array($estabelecimentos)) {
                if (count($estabelecimentos) == 0) {
                    throw new \Exception("Não foram encontrados estabelecimentos para a execução da rotina de conciliação");
                }
            }else {
                throw new \Exception("Não foram encontrados estabelecimentos para a execução da rotina de conciliação");
            }
        
            echo "............. Realizando as conciliações............. \n";
            $bool = array_map(function($estabelec) {
                echo "...... Estabelecimento: ".$estabelec."\n";
                return  Cnc_Equals::conciliacao(self::$connProc, $estabelec, self::$periodIni, self::$periodEnd);
            }, $estabelecimentos);

            $bool = array_reduce($bool, function($acc, $uniqueBool) {
                return $acc && $uniqueBool;
            }, true);
            
            $bool ? var_dump('A conciliação dos dados foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar executar a rotina de conciliação.');
            
            echo "............. Realizando a geração do financeiro (REC e BCO)............. \n";
            $bool = array_map(function($estabelec) {
                echo "...... Estabelecimento: ".$estabelec."\n";
                return  Cnc_Equals::geraFinanceiro(self::$connProc, $estabelec);
            }, $estabelecimentos);

            $bool = array_reduce($bool, function($acc, $uniqueBool) {
                return $acc && $uniqueBool;
            }, true);
            
            $bool ? var_dump('A geração de valores do Financeiro foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar gerar os valores do Financeiro.');
            
            oci_commit($conn);
            
        } catch (\Exception $e) {
            echo($e->getMessage());
        }

    }
    
    private static function openConnectionOnDB ($params) {
        // Conecta com a base de dados do sistema da Teknisa™
        // Link para a documentação das funções de OCI8 - http://php.net/manual/en/ref.oci8.php
        
        /* Conexao a ser usada quando o arquivo é aplicado no cliente  */
        if (USERNAME == 'USR_ORG_SAAS'){
            var_dump('USR_ORG_'.$params);
            $conn = oci_connect("/", "", 'USR_ORG_'.$params,"AL32UTF8", OCI_CRED_EXT);
        }else if(USERNAME == 'TESTE'){
            $conn = oci_connect('BAKEDPOTATO', 'teknisa', 'dbclientes.teknisa.com/DBTESTE_PDBORCL.bd.teknisasp.oraclevcn.com', 'AL32UTF8');
        }else{
            $conn = oci_connect("/", "", USERNAME,"AL32UTF8", OCI_CRED_EXT);
        }

        /* Conexao a ser usada quando o arquivo é aplicado para testes na Teknisa  */
        return $conn;
    }
    
    private static function CheckRetvenda ($conn) {
        $sql = 'SELECT COUNT(*) FROM RETVENDAADQ';
        $statement = oci_parse($conn, $sql);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        $returnFlag = oci_fetch_row($statement)[0];
        oci_free_statement($statement);
        oci_close($conn);
        return $returnFlag;
    }
    
    /*
     * Funcao abaixo corrige caracteres especiais em produtos por adquirentes
     * 
     * @param a: Conection
     * Infelizmente varios produtos foram homologados com caracteres especiais e apos migrar o servico para o php7 causou varios problemas na chamada da query que busca os produtos por adquirentes.
     */
    private static function ResolveSpecCarac ($conn) {
        try {
            $updates = array(
                '0' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'BANRICOMPRAS PRE-DATADO' 			 WHERE CDPRODUTOADQ = '314'",
                '1' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE ALIMENTACAO' 			 WHERE CDPRODUTOADQ = '389'",
                '2' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE PREMIACAO' 				 WHERE CDPRODUTOADQ = '390'",
                '3' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'GETNET TITULO' 					 WHERE CDPRODUTOADQ = '410'",
                '4' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO CARTAO DE CREDITO' 		 WHERE CDPRODUTOADQ = '417'",
                '5' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO DEBITO ONLINE (TEF)' 	 WHERE CDPRODUTOADQ = '419'",
                '6' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SAFRA PAY CREDITO' 				 WHERE CDPRODUTOADQ = '423'",
                '7' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SAFRA PAY DEBITO' 				 WHERE CDPRODUTOADQ = '424'",
                '8' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO CARTAO DE DEBITO' 		 WHERE CDPRODUTOADQ = '426'",
                '9' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'VEROCHEQUE CREDITO' 				 WHERE CDPRODUTOADQ = '427'",
                '10' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'VEROCHEQUE DEBITO' 				 WHERE CDPRODUTOADQ = '428'",
                '11' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'BEN VISA VALE REFEICAO' 			 WHERE CDPRODUTOADQ = '514'",
                '12' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'OUROCARD AGRO DEBITO' 			 WHERE CDPRODUTOADQ = '536'",
                '13' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO MULTIBENEFICIOS' 			 WHERE CDPRODUTOADQ = '540'",
                '14' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'MASTER PEDAGIO' 				     WHERE CDPRODUTOADQ = '318'",
                '15' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ELO CARNE' 				         WHERE CDPRODUTOADQ = '319'",
                '16' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'MASTER CARNE' 				     WHERE CDPRODUTOADQ = '320'",
                '17' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE CONVENIO' 				 WHERE CDPRODUTOADQ = '385'",
                '18' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SOROCRED CREDIARIO' 				 WHERE CDPRODUTOADQ = '416'",
                '19' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO DEPOSITO EM CONTA'      WHERE CDPRODUTOADQ = '422'",
                '20' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO REFEICAO' 					 WHERE CDPRODUTOADQ = '593'",
                '21' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO ALIMENTACAO' 				 WHERE CDPRODUTOADQ = '594'");
            foreach ($updates as $row) {
                $statement = oci_parse($conn, $row);
                oci_execute($statement, OCI_COMMIT_ON_SUCCESS);
                Cnc_Equals::makeCommit($conn);
            }
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Abstração para commit das alterações nas tabelas
     */
    private static function makeCommit ($conn) {
        oci_commit($conn);
        return 0;
    }
    
    /*
     * Implementação simples de um método que se comporta como um zip. Os dois arrays devem ter o mesmo tamanho.
     * 
     * @param a: primeiro array para o zip
     * @param b: segundo array para o zip
     *
     * @return [[String, String]]: array zip-like dos dois arrays parâmetros.
     */
    private static function zipTwo ($companies, $passwords) {
        return array_map(function($company, $password) {
            return array(
                'COMPANY'  => $company,
                'PASSWORD' => $password
            );
        }, $companies, $passwords);
    }
    
    /*
     * Muda sessao do banco
     * 
     */
    private static function session ($conn) {
        try {
            $querySession = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY'";

            $statement = oci_parse($conn, $querySession);
            oci_execute($statement, OCI_COMMIT_ON_SUCCESS);
            Cnc_Equals::makeCommit($conn);
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Inseri os dados desse acesso ao WS na tabela de controle do sistema. Quando o WS é executado, a tabela CONTROLEACESWS deve
     * receber dois novos registros, uma linha com os dados da conexão quando o sistema buscou o relátorio de vendas e outra linha
     * com as informações de quando o sistema buscou o relatório de pagamentos.
     *
     * @param conn: oci8 connection object
     * @param idTipo: qual tipo de acesso foi realizado: de relatório de vendas ('V') ou relatório de pagamentos ('P')
     */
    private static function RegisterWSAccess ($conn, $idTipo) {
        try {
            // Gera o NRSEQUENCIAL para a operação de insert
            $nrSeq = Cnc_Equals::GenerateNrSeq($conn, 'CONTROLEACESWS');
            // Define o valor do NRSEQCONTROLE globalmente para que ele possa ser utilizado por outros metôdos (outros
            // inserts)
            //self::$nrSeqControle = (int)$nrSeq;
            self::$nrSeqControle = 78510;

            // Inseri as informações de acesso
            $sql = "INSERT INTO CONTROLEACESWS (NRCTRLACESWS, IDTIPO, DTRETORNADA, DTACESSO, NRORG) VALUES (:P_NRSEQ, :P_IDTIPO, TO_DATE(:P_RESPONSEDATE,'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:P_ACCESSDATE,'DD/MM/YYYY HH24:MI:SS'), :P_NRORG)";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':P_NRSEQ', $nrSeq);
            oci_bind_by_name($statement, ':P_IDTIPO', $idTipo);
            oci_bind_by_name($statement, ':P_ACCESSDATE', self::$accessDate);
            oci_bind_by_name($statement, ':P_RESPONSEDATE', self::$responseDate);
            oci_bind_by_name($statement, ':P_NRORG', self::$nrorg);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);

            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_Equals::makeCommit($conn) : self::$rowBackCount;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Gera um NRSEQUENCIAL para a tabela especifícada para ser usado em uma operação de insert.
     *
     * @param conn: oci8 connection object
     * @param tableName: nome da tabela
     * @param nrSeq: NRSEQUENCIAL inicial. O default é não passar nenhum paramêtro para que se gere o NRSEQUENCIAL imediatamente
     * anterior ao mais recente na tabela NOVO_CODIGO
     * @param nrSeqLength: tamanho do inteiro gerado. O default é 20
     * @param qtd: quantidade de códigos que serão gerados. O default é sempre 1
     * @param nrorg: número da organização. O default é null
     *
     * @return o NRSEQUENCIAL gerado pela procedure que é armazenado na variável nrSeq
     */
    private static function GenerateNrSeq ($conn, $tableName, $nrSeq = '', $nrSeqLength = 20, $qtd = 1) {
        $sql = 'CALL NOVO_CODIGO_NT(:P_CONTADOR, :P_SEQUENCIAL, :P_QTDE)';
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':P_CONTADOR', $tableName);
        oci_bind_by_name($statement, ':P_SEQUENCIAL', $nrSeq, $nrSeqLength);
        oci_bind_by_name($statement, ':P_QTDE', $qtd);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        if (!$nrSeq) {
            throw new \Exception("Não foi possível gerar chave primária para a tabela -> ".$tableName);
        }
        return $nrSeq;
    }
    
    /*
     * Executa o sql para inserir o retorno de vendas do período.
     * O metódo recebe o array de vendas como paramêtro para que haja mais clareza na compreensão do propósito do metódo, apesar
     * da variável $salesArray ter escopo global na classe e poderia ser acessada sem esse paramêtro.
     *
     * @param conn: oci8 connection object
     * @param salesArray: array com o retorno das vendas
     * @return bool: booleano que sinaliza se o insert foi realizado com sucesso
     */
    private static function InsertSales ($conn, $salesArray) {
        try {
            $bool = false;
            foreach($salesArray as $sale) {
                // Define o sequencial de controle, FK da tabela de controle de acesso
                $sale[':NRCTRLACESWS'] = intval(self::$nrSeqControle);
                
                // Define o sequencial da adquirente baseado no nome da adquirente no relatório. O nome é utilizado pois o
                // relatório não possui nenhum campo que represente as adquirentes por um código numerico
                $canInsertAdq = false;
                $AdquirenteStrval = strtoupper(Cnc_Equals::tirarAcentos(strval($sale['adquirente']['nome'])));
                $sql = 'SELECT NRADQUIRENTE, CDADQUIRENTE FROM ADQUIRENTE WHERE CDADQUIRENTEEXT = :CdAdquirente';
                $statement = oci_parse($conn, $sql);
                oci_bind_by_name($statement, ":CdAdquirente", $sale['adquirente']['id']);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $result = oci_fetch_assoc($statement);
                
                if(!empty($result)) {
                    $sale[':NRADQUIRENTE'] = $result['NRADQUIRENTE'];
                    $sale[':CDADQUIRENTE'] = $result['CDADQUIRENTE'];
                    $canInsertAdq = true;
                } else {
                    $sql = 'SELECT NRADQUIRENTE, CDADQUIRENTE FROM ADQUIRENTE WHERE NMADQUIRENTE LIKE :Adquirente AND CDADQUIRENTEEXT IS NULL';
                    $statement = oci_parse($conn, $sql);
                    oci_bind_by_name($statement, ':Adquirente', $AdquirenteStrval);
                    oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $result = oci_fetch_assoc($statement);
                    
                    if(!empty($result)) {
                        $sale[':NRADQUIRENTE'] = $result['NRADQUIRENTE'];
                        $sale[':CDADQUIRENTE'] = $result['CDADQUIRENTE'];
                        
                        $sql = "UPDATE ADQUIRENTE SET CDADQUIRENTEEXT = :CdAdquirente WHERE NMADQUIRENTE LIKE :Adquirente AND CDADQUIRENTEEXT IS NULL";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":CdAdquirente", $sale['adquirente']['id']);
                        oci_bind_by_name($statement, ":Adquirente", $AdquirenteStrval);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $canInsertAdq = true;
                    } else {
                        echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale['adquirente']['nome'].". Ela será inserida no banco.";
                    
                        $sql = "DECLARE V_SEQVARCHAR VARCHAR2(20); BEGIN NOVO_CODIGO_NT('ADQUIRENTE', :V_SEQVARCHAR); END;";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":V_SEQVARCHAR", $NRADQUIRENTE, 20);
                        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sql = "SELECT TO_CHAR(MAX(CAST(CDADQUIRENTE AS INT)) + 1) AS NEWCDADQUIRENTE FROM ADQUIRENTE";
                        $statement = oci_parse($conn, $sql);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $result = oci_fetch_assoc($statement);
                        $sale[':NEWCDADQUIRENTE'] = $result['NEWCDADQUIRENTE'];
    
                        $NRADQUIRENTE = strval(ltrim($NRADQUIRENTE, "0"));
                        $CDADQUIRENTE = $sale[':NEWCDADQUIRENTE'];
                        $CDADQUIRENTEEXT = strval($sale['adquirente']['id']);
                        $NMADQUIRENTE = strtoupper(Cnc_Equals::tirarAcentos($sale['adquirente']['nome']));
                        $IDUTILIZADO = "S";
                        $IDVISIVEL = "N";
                        $IDATIVO = "S";
                        $IDGERAFINANC = "N";
                        $IDTXADMANT = "N";
                        $VRTAXAADM = 0;
                        $VRTOLERANCIA = 0.1;
                        $NRORG = self::$nrorg;
                        
                        $sql = "INSERT INTO ADQUIRENTE (NRADQUIRENTE, CDADQUIRENTE, NMADQUIRENTE, VRTAXAADM, VRTOLERANCIA, IDUTILIZADO, IDVISIVEL, NRORG, IDATIVO, IDGERAFINANC, IDTXADMANT) VALUES (:NRADQUIRENTE, :CDADQUIRENTE, :NMADQUIRENTE, :VRTAXAADM, :VRTOLERANCIA, :IDUTILIZADO, :IDVISIVEL, :NRORG, :IDATIVO, :IDGERAFINANC, :IDTXADMANT)";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":NRADQUIRENTE", $NRADQUIRENTE, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":CDADQUIRENTE", $CDADQUIRENTE);
                        oci_bind_by_name($statement, ":NMADQUIRENTE", $NMADQUIRENTE);
                        oci_bind_by_name($statement, ":VRTAXAADM", $VRTAXAADM, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":VRTOLERANCIA", $VRTOLERANCIA, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":IDUTILIZADO", $IDUTILIZADO);
                        oci_bind_by_name($statement, ":IDVISIVEL", $IDVISIVEL);
                        oci_bind_by_name($statement, ":NRORG", $NRORG, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":IDATIVO", $IDATIVO);
                        oci_bind_by_name($statement, ":IDGERAFINANC", $IDGERAFINANC);
                        oci_bind_by_name($statement, ":IDTXADMANT", $IDTXADMANT);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sale[':NRADQUIRENTE'] = $NRADQUIRENTE;
                        $sale[':CDADQUIRENTE'] = $CDADQUIRENTE;
                        
                        $canInsertAdq = true;
                    }
                }
                
                // Define o sequencial do produto baseado no campo de código do produto do relatório
                $canInsertProduto = false;
                $NomeProdutostrval = strtoupper(Cnc_Equals::tirarAcentos(strval($sale['loteVenda']['produto']['produto']['nome'])));
                $sql = "SELECT NRPRODUTOADQ, CDPRODUTOADQ FROM PRODUTOADQ WHERE CDPRODADQEXT = :CdProduto";
                $statement = oci_parse($conn, $sql);
                /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                $CdProdutostrval = strval($sale['loteVenda']['produto']['produto']['id']);
                oci_bind_by_name($statement, ':CdProduto', $CdProdutostrval);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $result = oci_fetch_assoc($statement);
                
                if(!empty($result)) {
                    $sale[':NRPRODUTOADQ'] = $result['NRPRODUTOADQ'];
                    $sale[':CDPRODUTOADQ'] = $result['CDPRODUTOADQ'];
                    $canInsertProduto = true;
                } else {
                    $sql = "SELECT NRPRODUTOADQ, CDPRODUTOADQ FROM PRODUTOADQ WHERE NMPRODUTOADQ = :NomeProduto AND CDPRODADQEXT IS NULL";
                    $statement = oci_parse($conn, $sql);
                    /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                    oci_bind_by_name($statement, ':NomeProduto', $NomeProdutostrval);
                    oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $result = oci_fetch_assoc($statement);
                    
                    if (!empty($result)) {
                        $sale[':NRPRODUTOADQ'] = $result['NRPRODUTOADQ'];
                        $sale[':CDPRODUTOADQ'] = $result['CDPRODUTOADQ'];
                        
                        $sql = "UPDATE PRODUTOADQ SET CDPRODADQEXT = :CdProduto WHERE NMPRODUTOADQ = :NomeProduto AND CDPRODADQEXT IS NULL";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":CdProduto", $CdProdutostrval);
                        oci_bind_by_name($statement, ":NomeProduto", $NomeProdutostrval);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $canInsertProduto = true;
                    } else {
                        $sql = "SELECT TO_CHAR(MAX(CAST(CDPRODUTOADQ AS INT)) + 1) AS NEWCDPRODUTOADQ FROM PRODUTOADQ";
                        $statement = oci_parse($conn, $sql);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $result = oci_fetch_assoc($statement);
                        $sale[':NEWCDPRODUTOADQ'] = $result['NEWCDPRODUTOADQ'];
                        
                        $sql = "DECLARE V_SEQVARCHAR VARCHAR2(20); BEGIN NOVO_CODIGO_NT('PRODUTOADQ', :V_SEQVARCHAR); END;";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":V_SEQVARCHAR", $NRPRODUTOADQ, 20);
                        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $NRPRODUTOADQ = strval(ltrim($NRPRODUTOADQ, "0"));
                        $CDPRODUTOADQ = strval($sale[':NEWCDPRODUTOADQ']);
                        $CDPRODADQEXT = $CdProdutostrval;
                        $NMPRODUTOADQ = $NomeProdutostrval;
                        $IDUTILIZADO = "S";
                        $IDVISIVEL = "N";
                        $IDATIVO = "S";
                        $NRORG = self::$nrorg;
                        
                        $sql = "INSERT INTO PRODUTOADQ (NRPRODUTOADQ, CDPRODUTOADQ, CDPRODADQEXT, NMPRODUTOADQ, IDUTILIZADO, IDVISIVEL, IDATIVO, NRORG) VALUES (:NRPRODUTOADQ, :CDPRODUTOADQ, :CDPRODADQEXT, :NMPRODUTOADQ, :IDUTILIZADO, :IDVISIVEL, :IDATIVO, :NRORG)";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":NRPRODUTOADQ", $NRPRODUTOADQ, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":CDPRODUTOADQ", $CDPRODUTOADQ);
                        oci_bind_by_name($statement, ":CDPRODADQEXT", $CDPRODADQEXT);
                        oci_bind_by_name($statement, ":NMPRODUTOADQ", $NMPRODUTOADQ);
                        oci_bind_by_name($statement, ":IDUTILIZADO", $IDUTILIZADO);
                        oci_bind_by_name($statement, ":IDVISIVEL", $IDVISIVEL);
                        oci_bind_by_name($statement, ":IDATIVO", $IDATIVO);
                        oci_bind_by_name($statement, ":NRORG", $NRORG, -1, OCI_B_INT);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sale[':NRPRODUTOADQ'] = $NRPRODUTOADQ;
                        $sale[':CDPRODUTOADQ'] = $CDPRODUTOADQ;
    
                        $canInsertProduto = true;
                    }
                }
                
                // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
                //in_array($sale['estabelecimento']['id'], self::$estabelec) ? true : self::$estabelec[] = $sale['estabelecimento']['id'];
                
            
                $sale[":ValorBruto"]     = str_replace(".", ",", floatval(($sale["valorVenda"])));
                $sale[":PercentualTaxa"] = str_replace(".", ",", floatval(($sale["taxaDesconto"])));
                $sale[":ValorTaxa"]      = str_replace(".", ",", floatval(($sale["valorComissao"])));
                $sale[":ValorLiquido"]   = str_replace(".", ",", floatval(($sale["valorLiquido"])));
                $sale[":ValorPago"]      = str_replace(".", ",", floatval(($sale["valorVenda"])));

                // Definição dos campos de auditoria
                $sale[':IDATIVO']       = 'S';
                $sale[':NRORG']         = self::$nrorg;
                $sale[':DTINCLUSAO']    = self::$responseDate;
                $sale[':DTULTATU']      = self::$responseDate;
                $sale[':NRORGINCLUSAO'] = self::$nrorg;

                // Concatena a data da venda ao hórario da transação para ser compatível com o formato date do banco de
                // dados oracle
                $sale[':HoraTransacao'] = date('d/m/Y' , strtotime($sale['dataTransacao'])).' '.(isset($sale['horaTransacao']) ? $sale['horaTransacao']: '00:01:01');

                // Converte os valores do relatório para caracteres, de forma que esses valores sejam compatíveis com os valores
                // possíveis para as colunas no BD
                switch ($sale['flagSituacao']) {
                    case 'L':
                        $sale[':Status'] = 'P'; /* Pago */
                        $sale[':Rejeitado'] = 'N';
                        $sale[':Cancelado'] = 'N';
                        $sale[':Pago'] = 'S';
                        break;
                    case 'R':
                        $sale[':Status'] = 'A'; /* Atrasado */
                        $sale[':Rejeitado'] = 'N';
                        $sale[':Cancelado'] = 'N';
                        $sale[':Pago'] = 'N';
                        break;
                    case 'C':
                        $sale[':Status'] = 'C'; /* Cancelado */
                        $sale[':Rejeitado'] = 'N';
                        $sale[':Cancelado'] = 'S';
                        $sale[':Pago'] = 'N';
                        break;
                    case 'A':
                        $sale[':Status'] = 'G'; /* Aguardando Pagamento */
                        $sale[':Rejeitado'] = 'S';
                        $sale[':Cancelado'] = 'N';
                        $sale[':Pago'] = 'N';
                        break;
                } // Verificar ~> Status

                switch ($sale['loteVenda']['produto']['produto']['produtoTipo']['id']) {
                    case '1':
                        $sale[':CodigoModalidade'] = 'C'; /* Credito a Vista */
                        break;
                    case '2':
                        $sale[':CodigoModalidade'] = 'D'; /* Débito */
                        break;
                    case '3':
                        $sale[':CodigoModalidade'] = 'P'; /* Crédito Parcelado  */
                        break;
                    case '4':
                        $sale[':CodigoModalidade'] = 'B'; /* Beneficio */
                        break;
                    case '5':
                        $sale[':CodigoModalidade'] = 'B'; /* Beneficio */
                        break;
                    case '20':
                        $sale[':CodigoModalidade'] = 'B'; /* Beneficio */
                        break;
                    case '24':
                        self::$Aplicativo++;
                        echo  'Vendas aplicativos: '.self::$Aplicativo;
                        $sale[':CodigoModalidade'] = 'A'; /* Aplicativo, IFOOD, sera implementado em breve */
                        break;
                    default:
                        $sale[':CodigoModalidade'] = 'O';
                } // Verificar ~> Código Modalidade

                //Verifica se existe o estabelecimento atual.
			    $idEstabelec = Cnc_Equals::CheckEstabelimento($conn, $sale['loteVenda']['numeroFiliacao'], $sale['estabelecimento']['nomeEstabelecimento']);
			        
			    if ($idEstabelec == 'N') {
			        echo "Não foi encontrado o Estabelecimento ".$sale['estabelecimento']['nomeEstabelecimento'].", com o Código Externo ".$sale['loteVenda']['numeroFiliacao'];
			        $canInsertEstabelec = false;
			    } else {
			        $sale[':Estabelecimento'] = Cnc_Equals::getNrEstabelec($conn, $sale['loteVenda']['numeroFiliacao']);
			        // Atualiza a tabela de controle de acesso para saber conter qual o estabelecimento o WS está tratando
                    Cnc_Equals::updateControleAcessWS($conn, $sale[":NRCTRLACESWS"], $sale[":Estabelecimento"]);
			        $canInsertEstabelec = true;
			    }

                // Verifica se o CNPJ do relatório pertence a alguma filial do BD. Se sim, atualiza os campos de filial do
                // estabelecimento atual
                //Cnc_Equals::CheckCNPJFilial($conn, $sale['estabelecimento']['cpfCnpj'], $sale[':Estabelecimento']);
                
                $dataVenda = date('d/m/Y' , strtotime($sale['dataTransacao']));
                
                // Chama o método que valida se a venda atual já está inserida
                $canInsert = Cnc_Equals::validateOrigVendaInsertion($conn, $sale['numeroNSU'], $sale['numeroAutorizacao'], $dataVenda);
                
                if ($canInsert && ($sale[':CodigoModalidade'] == 'B' || $sale[':CodigoModalidade'] == 'C' || $sale[':CodigoModalidade'] == 'D' || $sale[':CodigoModalidade'] == 'P') && $canInsertAdq && $canInsertProduto && $canInsertEstabelec) {
                    $venda = [];
                    // Gera NRRETORIGVENDA para a linha atual
                    $nrOrigVenda = Cnc_Equals::GenerateNrSeq($conn, 'RETORIGVENDA');
                    $venda[':NRRETORIGVENDA'] = intval($nrOrigVenda);
                    $venda[':Estabelecimento'] = intval($sale[':Estabelecimento']);
                    $venda[':Adquirente'] = $AdquirenteStrval;
                    $venda[':NRADQUIRENTE'] = ((isset($sale[':NRADQUIRENTE'])) ? intval($sale[':NRADQUIRENTE']): intval($NRADQUIRENTE));
                    $venda[':NRPRODUTOADQ'] = ((isset($sale[':NRPRODUTOADQ'])) ? intval($sale[':NRPRODUTOADQ']): intval($NRPRODUTOADQ));
                    $venda[':Parcela'] = intval($sale['loteVenda']['numeroParcela']);
                    $venda[':TotalParcelas'] = intval($sale['loteVenda']['numeroTotalParcela']);
                    $venda[':NRORG'] = intval($sale[':NRORG']);
                    $venda[':NRCTRLACESWS'] = intval($sale[':NRCTRLACESWS']);
                    $venda[':CodigoProduto'] = ((isset($sale[':CDPRODUTOADQ'])) ? $sale[':CDPRODUTOADQ']: $CDPRODUTOADQ);
                    $venda[':DescricaoProduto'] = $NomeProdutostrval;
                    $venda[':CodigoModalidade'] = $sale[':CodigoModalidade'];
                    $venda[':DescricaoModalidade'] = $sale['loteVenda']['produto']['produto']['produtoTipo']['nome'];
                    $venda[':DataVenda'] = $dataVenda;
                    $venda[':DataPrevistaPagto'] = date('d/m/Y' , strtotime($sale['loteVenda']['dataCaptura']));
                    $venda[':ResumoVenda'] = $sale['loteVenda']['id'];
                    $venda[':Autorizacao'] = $sale['numeroAutorizacao'];
                    $venda[':Cartao'] = ((isset($sale['numeroCartao'])) ? $sale['numeroCartao']: null);
                    $venda[':Nsu'] = $sale['numeroNSU'];
                    $venda[':ValorBruto'] = $sale[':ValorBruto'];
                    $venda[':PercentualTaxa'] = $sale[':PercentualTaxa'];
                    $venda[':ValorTaxa'] = $sale[':ValorTaxa'];
                    $venda[':ValorLiquido'] = $sale[':ValorLiquido'];
                    $venda[':Agencia'] = ((isset($sale['loteVenda']['agencia'])) ? $sale['loteVenda']['agencia']: null);
                    $venda[':Conta'] = ((isset($sale['loteVenda']['contaCorrente'])) ? $sale['loteVenda']['contaCorrente']: null);
                    $venda[':HoraTransacao'] = $sale[':HoraTransacao'];
                    $venda[':Status'] = $sale[':Status'];
                    $venda[':Rejeitado'] = $sale[':Rejeitado'];
                    $venda[':Cancelado'] = $sale[':Cancelado'];
                    $venda[':DataPagamento'] = date('d/m/Y' , strtotime($sale['dataSituacao']));
                    $venda[':ValorPago'] = $sale[':ValorPago'];
                    $venda[':IDATIVO'] = $sale[':IDATIVO'];
                    $venda[':DTINCLUSAO'] = $sale[':DTINCLUSAO'];
                    $venda[':DTULTATU'] = $sale[':DTULTATU'];
                    $venda[':NRORGINCLUSAO'] = $sale[':NRORGINCLUSAO'];
                    $venda[':Terminal'] = ((isset($sale['terminal']['numeroTerminal'])) ? $sale['terminal']['numeroTerminal']: null);
                    $venda[':Banco'] = ((isset($sale['loteVenda']['banco'])) ? $sale['loteVenda']['banco']: null); 
                    $sql = "INSERT INTO RETORIGVENDA (NRRETORIGVENDA, NRCTRLACESWS, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, IDMODALIDADE, DSMODALIDADE, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, NRCARTAOTRUNC, CDNSU, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, NRTERMINAL, CDBANCO, CDAGENCIA, CDCONTCORR, DTHORATRANS, NRPARCELA, NRQTPARCELA, IDSTATUS, IDREJEITADO, IDCANCELADO, DTPGTO, VRLIQPGTO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO) 
                                              VALUES (TO_NUMBER(:NRRETORIGVENDA), TO_NUMBER(:NRCTRLACESWS), TO_NUMBER(:Estabelecimento), :Adquirente, TO_NUMBER(:NRADQUIRENTE), :CodigoProduto, :DescricaoProduto, TO_NUMBER(:NRPRODUTOADQ), :CodigoModalidade, :DescricaoModalidade, TO_DATE(:DataVenda, 'DD/MM/YYYY'), TO_DATE(:DataPrevistaPagto, 'DD/MM/YYYY'), :ResumoVenda, :Autorizacao, :Cartao, :Nsu, TO_NUMBER(:ValorBruto), TO_NUMBER(:PercentualTaxa), TO_NUMBER(:ValorTaxa), TO_NUMBER(:ValorLiquido), :Terminal, :Banco, :Agencia, :Conta, TO_DATE(:HoraTransacao, 'DD/MM/YYYY HH24:MI:SS'), TO_NUMBER(:Parcela), TO_NUMBER(:TotalParcelas), :Status, :Rejeitado, :Cancelado, TO_DATE(:DataPagamento, 'DD/MM/YYYY'), TO_NUMBER(:ValorPago), TO_NUMBER(:NRORG), :IDATIVO, TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:DTULTATU, 'DD/MM/YYYY HH24:MI:SS'), TO_NUMBER(:NRORGINCLUSAO))";
                    $statement = oci_parse($conn, $sql);
                    // Executa os binds necessários para substituir os paramêtros pelos valores que serão gravados. Os campos Pago e
                    // Cancelamento do relatório são ignorados pois a função deles foi incorporada em uma única coluna (IDSTATUS) no
                    // nosso sistema. O campo CNPJ não é parte das colunas da tabela RETORIGVENDA
                    foreach ($venda as $key => $value){
                        if ($key != ':Pago' && $key != ':Cnpj' && $key != ':Cnpj' && $key != ':Tid' && $key != ':Observacao' && $key != ':Cancelamento' && $key != ':Pedido'){
                            oci_bind_by_name($statement, $key, $venda[$key]);
                            /* A Ticket e a VR não informam código do lote*/
                            //var_dump($key);
                            //var_dump($value);
                            if ($key == ':Adquirente' && ($value == 'Ticket' || $value == 'VR' || $value == 'Valecard' || $value == 'Safra Pay')){
                                $strResumoVenda = ':ResumoVenda';
                                $strNULL = NULL;
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            }
                            /* A PagSeguro não informa Agencia e conta lote*/
                            if ($key == ':Adquirente' && ($value == 'PagSeguro')){
                                $strNULL = NULL;
                                $strResumoVenda = ':ResumoVenda';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                                $strResumoVenda = ':Agencia';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                                $strResumoVenda = ':Conta';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
            			    }
            			    /* Em casos que a data de pagamentno vem vazia inserimos NULL*/
                            //if ($key == ':DataPagamento' && (strlen($sale[':DataPagamento']) < 10)){
                            //    $strResumoVenda = ':DataPagamento';
                            //    $strNULL = NULL;
                            //    oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            //}
            			    /* Ifood em alguns casos nao envia numero do cartao*/
                            if ($key == ':Adquirente' && ($value == 'Ifood')){
                                $strResumoVenda = ':Cartao';
                                $strNULL = NULL;
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            }
            			}
        		    }

                    $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $e = oci_error($statement);
                    if ($e) {
                        //var_dump($sale);
                        throw new \Exception($e["message"]);
                    } else {
                        self::$rowBackCount++;
                        self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_Equals::makeCommit($conn) : self::$rowBackCount;
                    }
                }
            }
        return $bool;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    // Função de retirar acentos.
    private static function tirarAcentos($string){
        return preg_replace(array("/(á|à|ã|â|ä)/","/(Á|À|Ã|Â|Ä)/","/(é|è|ê|ë)/","/(É|È|Ê|Ë)/","/(í|ì|î|ï)/","/(Í|Ì|Î|Ï)/","/(ó|ò|õ|ô|ö)/","/(Ó|Ò|Õ|Ô|Ö)/","/(ú|ù|û|ü)/","/(Ú|Ù|Û|Ü)/","/(ñ)/","/(Ñ)/", "/(ç)/"),explode(" ","a A e E i I o O u U n N c"),$string);
    }
    
    /*
     * Verifica se o estabelimento informado possui registro na tabela de Estabelimento, e inseri o estabelimento em casos negativos
     *
     * @param conn: oci8 connection object
     * @param estabelecimento: número do estabelecimento informado no relatório
     */
    private static function CheckEstabelimento ($conn, $codigoEstabelec, $nomeEstabelec) {
        $sql = 'SELECT * FROM ESTABELECIMENTO WHERE TO_NUMBER(CDESTABELEC) = TO_NUMBER(:CDESTABELEC)';
        $statement = oci_parse($conn, $sql);
        $EstabelecimentoStrval = strval($codigoEstabelec);
        oci_bind_by_name($statement, ':CDESTABELEC', $EstabelecimentoStrval);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        $result = oci_fetch_assoc($statement);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        if (empty($result['NRESTABELEC'])) {
            $nrSeq = Cnc_Equals::GenerateNrSeq($conn, 'ESTABELECIMENTO');

            $sql = "INSERT INTO ESTABELECIMENTO (NRESTABELEC, CDESTABELEC, NRORG, IDATIVO) VALUES (:NRESTABELEC, TO_CHAR(TO_NUMBER(:CDESTABELEC)), :NRORG, 'S')";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':NRESTABELEC', $nrSeq);
            $EstabelecimentoStrval = strval($codigoEstabelec);
            oci_bind_by_name($statement, ':CDESTABELEC', $EstabelecimentoStrval);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);

            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
        }
    }
    
    /*
     * Seleciona e retorna o NRESTABELEC de uma linha da tabela Estabelecimento buscando pelo código do estabelecimento
     *
     * @param conn: oci8 connection object
     * @param estabelecimento: número do estabelecimento informado no relatório
     *
     * @return string: número do estabelecimento retornado pelo select
     */
    private static function getNrEstabelec ($conn, $estabelecimento) {
        $sql = "SELECT NRESTABELEC FROM ESTABELECIMENTO WHERE TO_NUMBER(CDESTABELEC) = TO_NUMBER(:CDESTABELEC)";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':CDESTABELEC', $estabelecimento);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return oci_fetch_row($statement)[0];
    }
    
    /*
     * Atualiza a CONTROLEACESWS para conter o estabelecimento no qual o WS esteve
     * 
     * @param conn: oci8 connection obj
     * @param acessws: chave primária do controle de acesso atual
     * @param estabelec: estabelecimento que o WS está atualmente tratando
     */
    private static function updateControleAcessWS ($conn, $acessws, $estabelec) {
        $sql = "UPDATE CONTROLEACESWS SET NRESTABELEC = :NRESTABELEC WHERE NRCTRLACESWS = :NRCTRLACESWS";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ":NRESTABELEC", $estabelec);
        oci_bind_by_name($statement, ":NRCTRLACESWS", $acessws);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
    }
    
    /*
     * Verifica se o CNPJ passado pertence a alguma filial já cadastrada. Se sim, atualiza os campos de filial para o estabelecimento
     * passado.
     *
     * @param conn: oci8 connection object
     * @param cnpj: número do CNPJ da row atual do relatório
     * @param estabelec: número do estabelecimento da row atual do relatório
     */
    private static function CheckCNPJFilial ($conn, $cnpj, $estabelec) {
        $sql = "SELECT CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRINSJURFILI FROM FILIAL WHERE NRORG = :NRORG AND NRINSJURFILI = :CNPJ";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_bind_by_name($statement, ':CNPJ', $cnpj);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        $fili = oci_fetch_assoc($statement);
        $fili["NMFILIAL"] = empty($fili["NMFILIAL"]) ? "" : $fili["NMFILIAL"];
        
        if ($fili) {
            $sql = "UPDATE ESTABELECIMENTO SET CDFILIAL = :CDFILIAL, NMESTABELEC = :NMESTABELEC, NRCNPJESTABELEC = :CNPJ, CDEMPRESA = :CDEMPRESA, CDINSCESTA = :CDINSCESTA, CDINSCMUNI = :CDINSCMUNI WHERE NRORG = :NRORG AND NRESTABELEC = :NRESTABELEC";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDFILIAL', $fili["CDFILIAL"]);
            oci_bind_by_name($statement, ":NMESTABELEC", $fili["NMFILIAL"]);
            oci_bind_by_name($statement, ':CNPJ', $cnpj);
            oci_bind_by_name($statement, ':CDEMPRESA', $fili["CDEMPRESA"]);
            oci_bind_by_name($statement, ":CDINSCESTA", $fili["CDINSCESTA"]);
            oci_bind_by_name($statement, ':CDINSCMUNI', $fili["CDINSCMUNI"]);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_bind_by_name($statement, ':NRESTABELEC', $estabelec);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_Equals::makeCommit($conn) : self::$rowBackCount;
        }
    }
    
    /*
     * Verifica se na tabela RETORIGVENDA, já está inserido o registro em questão utilizando a data da venda, o NSU e o 
     * código da autorização, como parâmetros para busca da linha.
     *
     * @param conn: oci8 connection object
     * @param nsu
     * @param autorizacao
     * @param dtvenda
     *
     * @return bool: true se a o select não encontrar nenhuma linha com os dados da filtragem, false caso contrário.
     */
    private static function validateOrigVendaInsertion ($conn, $nsu, $autorizacao, $dtvenda) {
        $NRORG = self::$nrorg;
        
        $sql = "SELECT COUNT(*) LINHAS FROM RETORIGVENDA WHERE CDNSU = :CDNSU AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTVENDA = TO_DATE(:DTVENDA, 'DD/MM/YYYY') AND NRORG = :NRORG";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':CDNSU', $nsu);
        oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
        oci_bind_by_name($statement, ':DTVENDA', $dtvenda);
        oci_bind_by_name($statement, ':NRORG', $NRORG, -1, OCI_B_INT);
        //var_dump($nsu, $autorizacao, $dtvenda, $NRORG);die;
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return intval(oci_fetch_assoc($statement)["LINHAS"]) == 0 ? true : false;
    }
    
    private static function replicaDadosProc ($conn, $boolInsert) {
        $P_DTINICIAL = self::$periodIni;
        $P_DTFINAL = self::$periodEnd;
        
        if ($boolInsert == true) {
            $boolInsert = 'S';
        } else {
           $boolInsert = 'N'; 
        }
        
        $sql = "BEGIN REPLICA_DADOS_CNC_EQUALS(TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'), :P_NRSEQCONTROLE, NULL, :V_IDINSERT); END;";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
        oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
        oci_bind_by_name($statement, ':P_NRSEQCONTROLE', self::$nrSeqControle);
        oci_bind_by_name($statement, ':V_IDINSERT', $boolInsert);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return $bool;
    }
    
    /*
     * Executa o sql para inserir o retorno de pagamentos do período.
     * O metódo recebe o array de pagamentos como paramêtro para que haja mais clareza na compreensão do propósito do metódo,
     * apesar da variável $paymentsArray ter escopo global na classe e poderia ser acessada sem esse paramêtro.
     *
     * @param conn: oci8 connection object
     * @param paymentsArray: array com o retorno das pagamentos
     *
     * @return bool: booleano que sinaliza se o insert foi realizado com sucesso
     */
    private static function InsertPayments ($conn, $paymentsArray) {
        try {
            $bool = false;
            foreach ($paymentsArray as $payment) {
                $payment[':NRCTRLACESWS'] = self::$nrSeqControle;

                // Define o sequencial da adquirente baseado no nome da adquirente no relatório. O nome é utilizado pois o
                // relatório não possui nenhum campo que represente as adquirentes por um código numerico
                $canInsertAdq = false;
                $AdquirenteStrval = strtoupper(Cnc_Equals::tirarAcentos(strval($sale['adquirente']['nome'])));
                $sql = 'SELECT NRADQUIRENTE, CDADQUIRENTE FROM ADQUIRENTE WHERE CDADQUIRENTEEXT = :CdAdquirente';
                $statement = oci_parse($conn, $sql);
                oci_bind_by_name($statement, ":CdAdquirente", $sale['adquirente']['id']);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $sale[':NRADQUIRENTE'] = oci_fetch_assoc($statement)['NRADQUIRENTE'];
                $sale[':CDADQUIRENTE'] = oci_fetch_assoc($statement)['CDADQUIRENTE'];
                
                if($sale[':NRADQUIRENTE']) {
                    $canInsertAdq = true;
                } else {
                    $sql = 'SELECT NRADQUIRENTE, CDADQUIRENTE FROM ADQUIRENTE WHERE NMADQUIRENTE LIKE :Adquirente AND CDADQUIRENTEEXT IS NULL';
                    $statement = oci_parse($conn, $sql);
                    oci_bind_by_name($statement, ':Adquirente', $AdquirenteStrval);
                    oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $sale[':NRADQUIRENTE'] = oci_fetch_assoc($statement)['NRADQUIRENTE'];
                    $sale[':CDADQUIRENTE'] = oci_fetch_assoc($statement)['CDADQUIRENTE'];
                    
                    if($sale[':NRADQUIRENTE']) {
                        $sql = "UPDATE ADQUIRENTE SET CDADQUIRENTEEXT = :CdAdquirente WHERE NMADQUIRENTE LIKE :Adquirente AND CDADQUIRENTEEXT IS NULL";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":CdAdquirente", $sale['adquirente']['id']);
                        oci_bind_by_name($statement, ":Adquirente", $AdquirenteStrval);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $canInsertAdq = true;
                    } else {
                        echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale['adquirente']['nome'].". Ela será inserida no banco.";
                    
                        $sql = "DECLARE V_SEQVARCHAR VARCHAR2(20); BEGIN NOVO_CODIGO_NT('ADQUIRENTE', :V_SEQVARCHAR); END;";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":V_SEQVARCHAR", $NRADQUIRENTE, 20);
                        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sql = "SELECT TO_CHAR(MAX(CAST(CDADQUIRENTE AS INT)) + 1) AS NEWCDADQUIRENTE FROM ADQUIRENTE";
                        $statement = oci_parse($conn, $sql);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $result = oci_fetch_assoc($statement);
                        $sale[':NEWCDADQUIRENTE'] = $result['NEWCDADQUIRENTE'];
    
                        $NRADQUIRENTE = strval(ltrim($NRADQUIRENTE, "0"));
                        $CDADQUIRENTE = $sale[':NEWCDADQUIRENTE'];
                        $CDADQUIRENTEEXT = strval($sale['adquirente']['id']);
                        $NMADQUIRENTE = strtoupper(Cnc_Equals::tirarAcentos($sale['adquirente']['nome']));
                        $IDUTILIZADO = "S";
                        $IDVISIVEL = "N";
                        $IDATIVO = "S";
                        $IDGERAFINANC = "N";
                        $IDTXADMANT = "N";
                        $VRTAXAADM = 0;
                        $VRTOLERANCIA = 0.1;
                        $NRORG = self::$nrorg;
                        
                        $sql = "INSERT INTO ADQUIRENTE (NRADQUIRENTE, CDADQUIRENTE, NMADQUIRENTE, VRTAXAADM, VRTOLERANCIA, IDUTILIZADO, IDVISIVEL, NRORG, IDATIVO, IDGERAFINANC, IDTXADMANT) VALUES (:NRADQUIRENTE, :CDADQUIRENTE, :NMADQUIRENTE, :VRTAXAADM, :VRTOLERANCIA, :IDUTILIZADO, :IDVISIVEL, :NRORG, :IDATIVO, :IDGERAFINANC, :IDTXADMANT)";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":NRADQUIRENTE", $NRADQUIRENTE, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":CDADQUIRENTE", $CDADQUIRENTE);
                        oci_bind_by_name($statement, ":NMADQUIRENTE", $NMADQUIRENTE);
                        oci_bind_by_name($statement, ":VRTAXAADM", $VRTAXAADM, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":VRTOLERANCIA", $VRTOLERANCIA, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":IDUTILIZADO", $IDUTILIZADO);
                        oci_bind_by_name($statement, ":IDVISIVEL", $IDVISIVEL);
                        oci_bind_by_name($statement, ":NRORG", $NRORG, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":IDATIVO", $IDATIVO);
                        oci_bind_by_name($statement, ":IDGERAFINANC", $IDGERAFINANC);
                        oci_bind_by_name($statement, ":IDTXADMANT", $IDTXADMANT);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sale[':NRADQUIRENTE'] = $NRADQUIRENTE;
                        $sale[':CDADQUIRENTE'] = $CDADQUIRENTE;
                        
                        $canInsertAdq = true;
                    }
                }
                
                // Define o sequencial do produto baseado no campo de código do produto do relatório
                $NomeProdutostrval = strtoupper(Cnc_Equals::tirarAcentos(strval($sale['loteVenda']['produto']['produto']['nome'])));
                $sql = "SELECT NRPRODUTOADQ, CDPRODUTOADQ FROM PRODUTOADQ WHERE CDPRODADQEXT = :CdProduto";
                $statement = oci_parse($conn, $sql);
                /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                $CdProdutostrval = strval($sale['loteVenda']['produto']['produto']['id']);
                oci_bind_by_name($statement, ':CdProduto', $CdProdutostrval);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $result = oci_fetch_assoc($statement);
                $sale[':NRPRODUTOADQ'] = $result['NRPRODUTOADQ'];
                $sale[':CDPRODUTOADQ'] = $result['CDPRODUTOADQ'];
                
                if ($sale[':NRPRODUTOADQ']) {
                    $canInsertProduto = true;
                } else {
                    $sql = "SELECT NRPRODUTOADQ, CDPRODUTOADQ FROM PRODUTOADQ WHERE NMPRODUTOADQ = :NomeProduto AND CDPRODADQEXT IS NULL";
                    $statement = oci_parse($conn, $sql);
                    /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                    oci_bind_by_name($statement, ':NomeProduto', $NomeProdutostrval);
                    oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $result = oci_fetch_assoc($statement);
                    $sale[':NRPRODUTOADQ'] = $result['NRPRODUTOADQ'];
                    $sale[':CDPRODUTOADQ'] = $result['CDPRODUTOADQ'];
                    
                    if ($sale[':NRPRODUTOADQ']) {
                        $sql = "UPDATE PRODUTOADQ SET CDPRODADQEXT = :CdProduto WHERE NMPRODUTOADQ = :NomeProduto AND CDPRODADQEXT IS NULL";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":CdProduto", $CdProdutostrval);
                        oci_bind_by_name($statement, ":NomeProduto", $NomeProdutostrval);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $canInsertProduto = true;
                    } else {
                        $sql = "SELECT TO_CHAR(MAX(CAST(CDPRODUTOADQ AS INT)) + 1) AS NEWCDPRODUTOADQ FROM PRODUTOADQ";
                        $statement = oci_parse($conn, $sql);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        $result = oci_fetch_assoc($statement);
                        $sale[':NEWCDPRODUTOADQ'] = $result['NEWCDPRODUTOADQ'];
                        
                        $sql = "DECLARE V_SEQVARCHAR VARCHAR2(20); BEGIN NOVO_CODIGO_NT('PRODUTOADQ', :V_SEQVARCHAR); END;";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":V_SEQVARCHAR", $NRPRODUTOADQ, 20);
                        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $NRPRODUTOADQ = strval(ltrim($NRPRODUTOADQ, "0"));
                        $CDPRODUTOADQ = strval($sale[':NEWCDPRODUTOADQ']);
                        $CDPRODADQEXT = $CdProdutostrval;
                        $NMPRODUTOADQ = $NomeProdutostrval;
                        $IDUTILIZADO = "S";
                        $IDVISIVEL = "N";
                        $IDATIVO = "S";
                        $NRORG = self::$nrorg;
                        
                        $sql = "INSERT INTO PRODUTOADQ (NRPRODUTOADQ, CDPRODUTOADQ, CDPRODADQEXT, NMPRODUTOADQ, IDUTILIZADO, IDVISIVEL, IDATIVO, NRORG) VALUES (:NRPRODUTOADQ, :CDPRODUTOADQ, :CDPRODADQEXT, :NMPRODUTOADQ, :IDUTILIZADO, :IDVISIVEL, :IDATIVO, :NRORG)";
                        $statement = oci_parse($conn, $sql);
                        oci_bind_by_name($statement, ":NRPRODUTOADQ", $NRPRODUTOADQ, -1, OCI_B_INT);
                        oci_bind_by_name($statement, ":CDPRODUTOADQ", $CDPRODUTOADQ);
                        oci_bind_by_name($statement, ":CDPRODADQEXT", $CDPRODADQEXT);
                        oci_bind_by_name($statement, ":NMPRODUTOADQ", $NMPRODUTOADQ);
                        oci_bind_by_name($statement, ":IDUTILIZADO", $IDUTILIZADO);
                        oci_bind_by_name($statement, ":IDVISIVEL", $IDVISIVEL);
                        oci_bind_by_name($statement, ":IDATIVO", $IDATIVO);
                        oci_bind_by_name($statement, ":NRORG", $NRORG, -1, OCI_B_INT);
                        oci_execute($statement, OCI_NO_AUTO_COMMIT);
                        
                        $sale[':NRPRODUTOADQ'] = $NRPRODUTOADQ;
                        $sale[':CDPRODUTOADQ'] = $CDPRODUTOADQ;
    
                        $canInsertProduto = true;
                    }
                }

                // Calcula o valor líquido a ser pago pela adquirente e a taxa cobrada pela venda
                $payment[":ValorBruto"]    = floatval(str_replace(",", ".", $payment['valor']));
                $payment[":Taxa"]          = floatval(str_replace(",", ".", $payment['valorAdicional']));
                $payment[":ValorLiquido"]  = floatval(str_replace(",", ".", $payment['valorLiquido']));
                $payment[':VRLIQVENDA']    = str_replace(".", ",", floatval($payment[":ValorBruto"] - $payment[":ValorBruto"] * ($payment[":Taxa"] / 100)));
                $payment[':VRCOBRADOTAXA'] = str_replace(".", ",", floatval($payment[":ValorBruto"] - $payment[":ValorLiquido"]));
                $dataVenda = date('d/m/Y' , strtotime($payment['vendaErpPrincipal']['dataVenda']));
                
                // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
                //in_array($payment['estabelecimento']['id'], self::$estabelec) ? true : self::$estabelec[] = $payment['estabelecimento']['id'];

                // Definição dos campos de auditoria
                $payment[':IDATIVO']       = 'S';
                $payment[':NRORG']         = self::$nrorg;
                $payment[':DTINCLUSAO']    = self::$responseDate;
                $payment[':DTULTATU']      = self::$responseDate;
                $payment[':NRORGINCLUSAO'] = self::$nrorg;
                $payment[':NRORGULTATU']   = self::$nrorg;

                // Converte os valores do relatório para caracteres, de forma que esses valores sejam compatíveis com os valores
                // possíveis para as colunas no BD
                $payment['antecipado'] = $payment['situacao'] === 'A' ? 'S' : 'N';

                $payment[':IdTipoTransacao'] = 'P';

                //Verifica se existe o estabelecimento atual.
			    $idEstabelec = Cnc_Equals::CheckEstabelimento($conn, $payment['estabelecimento'], 'SEM NOME');
			        
			    if ($idEstabelec == 'N') {
			        echo "Não foi encontrado o Estabelecimento com o Código Externo ".$payment['estabelecimento'];
			        $canInsertEstabelec = false;
			    } else {
			        $payment[':Estabelecimento'] = Cnc_Equals::getNrEstabelec($conn, $payment['estabelecimento']);
			        $canInsertEstabelec = true;
			    }
                
                // Atualiza a tabela de controle de acesso para conter qual o estabelecimento o WS está tratando
                Cnc_Equals::updateControleAcessWS($conn, $payment[":NRCTRLACESWS"], $payment[":Estabelecimento"]);

                // Verifica se o CNPJ do relatório pertence a alguma filial do BD. Se sim, atualiza os campos de filial do
                // estabelecimento atual
                //Cnc_Equals::CheckCNPJFilial($conn, $payment['cnpj'], $payment[':Estabelecimento']); // Verificar ~> CNPJ
                
                // Chama o método que valida se o pagamento atual já está inserido
                $canInsert = Cnc_Equals::validateOrigFinancInsertion($conn,
                                                                 $payment['numeroNSU'],
                                                                 $payment['numeroAutorizacao'],
                                                                 date('d/m/Y' , strtotime($payment['dataTransacao'])),
                                                                 $payment[':ValorBruto'],
                                                                 $payment['loteVendaERP']['numero']);
                if ($canInsert && !!$payment[':IdTipoTransacao'] && $canInsertAdq && $canInsertPag && $canInsertEstabelec) {
                    $pagamento = [];
                    // Gera NRRETORIGVENDA para a linha atual
                    $nrOrigPgto = Cnc_Equals::GenerateNrSeq($conn, 'RETORIGFINANC');
                    $pagamento[':NRRETORIGFINANC'] = intval($nrOrigPgto);
                    $pagamento[':NRCTRLACESWS'] = intval($payment[':NRCTRLACESWS']);
                    $pagamento[':Estabelecimento'] = intval($payment[':Estabelecimento']);
                    $pagamento[':Adquirente'] = $AdquirenteStrval;
                    $pagamento[':NRADQUIRENTE'] = ((isset($payment[':NRADQUIRENTE'])) ? $payment[':NRADQUIRENTE']: $NRADQUIRENTE);
                    $pagamento[':NRPRODUTOADQ'] = ((isset($payment[':NRPRODUTOADQ'])) ? $payment[':NRPRODUTOADQ']: $NRPRODUTOADQ);
                    $pagamento[':CodigoProduto'] = ((isset($payment[':CDPRODUTOADQ'])) ? $payment[':CDPRODUTOADQ']: $CDPRODUTOADQ);
                    $pagamento[':DescricaoProduto'] = $NomeProdutostrval;
                    $pagamento[':DataVenda'] = $dataVenda;
                    $pagamento[':DataPagamento'] = date('d/m/Y', strtotime($payment['dataTransacao']));
                    $pagamento[':ResumoVenda'] = $payment['loteVendaERP']['id'];
                    $pagamento[':Autorizacao'] = $payment['numeroAutorizacao'];
                    $pagamento[':NSU'] = $payment['numeroNSU'];
                    $pagamento[':TID'] = $payment['numeroTID'];
                    $pagamento[':ValorBruto'] = $payment[':ValorBruto'];
                    $pagamento[':Taxa'] = $payment[':Taxa'];
                    $pagamento[':VRCOBRADOTAXA'] = $payment[':VRCOBRADOTAXA'];
                    $pagamento[':VRLIQVENDA'] = $payment[':VRLIQVENDA'];
                    $pagamento[':Banco'] = ((isset($payment['loteVenda']['banco'])) ? $payment['loteVenda']['banco']: null);
                    $pagamento[':Agencia'] = ((isset($payment['loteVenda']['agencia'])) ? $payment['loteVenda']['agencia']: null);
                    $pagamento[':Conta'] = ((isset($payment['loteVenda']['contaCorrente'])) ? $payment['loteVenda']['contaCorrente']: null);
                    $pagamento[':Parcela'] = intval($payment['numeroParcela']);
                    $pagamento[':TotalParcelas'] = ((isset($payment['TotalParcelas'])) ? $payment['TotalParcelas']: null);
                    $pagamento[':Antecipacao'] = $payment['antecipado'];
                    $pagamento[':IdTipoTransacao'] = $payment['IdTipoTransacao'];
                    $pagamento[':TipoTransacao'] = ((isset($payment['TipoTransacao'])) ? $payment['TipoTransacao']: null);
                    $pagamento[':NRORG'] = intval($payment[':NRORG']);
                    $pagamento[':IDATIVO'] = $payment[':IDATIVO'];
                    $pagamento[':DTINCLUSAO'] = $payment[':DTINCLUSAO'];
                    $pagamento[':DTULTATU'] = $payment[':DTULTATU'];
                    $pagamento[':NRORGINCLUSAO'] = $payment[':NRORGINCLUSAO'];
                    $pagamento[':NRORGULTATU'] = $payment[':NRORGINCLUSAO'];

                    $sql = "INSERT INTO RETORIGFINANC (NRRETORIGFINANC, NRCTRLACESWS, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, CDNSU, NRTID, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, CDBANCO, CDAGENCIA, CDCONTCORR, NRPARCELA, NRQTPARCELA, IDANTECIPADO, IDTIPOTRANS, DSTRANSACAO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU ) VALUES (:NRRETORIGFINANC, :NRCTRLACESWS, :Estabelecimento, UPPER(:Adquirente), :NRADQUIRENTE, :CDPRODUTOADQ, :TipoProduto, :NRPRODUTOADQ, TO_DATE(:DataVenda, 'DD/MM/YYYY'), TO_DATE(:DataPagamento, 'DD/MM/YYYY'), :ResumoVenda, :Autorizacao, :NSU, :TID, TO_NUMBER(:ValorBruto), TO_NUMBER(:Taxa), ROUND(TO_NUMBER(:VRCOBRADOTAXA), 2), ROUND(TO_NUMBER(:VRLIQVENDA), 2), :Banco, :Agencia, :Conta, :Parcela, :TotalParcelas, :Antecipacao, :IdTipoTransacao, :TipoTransacao, :NRORG, :IDATIVO, TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:DTULTATU, 'DD/MM/YYYY HH24:MI:SS'), :NRORGINCLUSAO, :NRORGULTATU)";
                    $statement = oci_parse($conn, $sql);
                    // Executa os binds necessários para substituir os paramêtros pelos valores que serão gravados. Alguns campos são
                    // ignorados no bind por não possuírem coluna correspondente na tabela do BD.
                    foreach ($pagamento as $key => $value) {
                        oci_bind_by_name($statement, $key, $pagamento[$key]);
                    }
                                                
                    $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $e = oci_error($statement);
                    if ($e) {
                        throw new \Exception($e["message"]);
                    } else {
                        self::$rowBackCount++;
                        self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_Equals::makeCommit($conn) : self::$rowBackCount;
                    }
                }
            }

            return $bool;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Verifica se na tabela RETORIGFINANC, já está inserido o registro em questão utilizando a data da venda, o NSU e o 
     * código da autorização, como parâmetros para busca da linha.
     *
     * @param conn: oci8 connection object
     * @param nsu
     * @param autorizacao
     * @param dtcredito
     *
     * @return bool: true se a o select não encontrar nenhuma linha com os dados da filtragem, false caso contrário.
     */
    private static function validateOrigFinancInsertion ($conn, $nsu, $autorizacao, $dtcredito, $vrbruto, $cdlotevenda) {
        //Garante que o formato do DTCREDITO será sempre DD/MM/YYYY
	    $dtcredito = explode('/', $dtcredito);
	    $year = $dtcredito[2];
	    if(strlen($year) != 4 ){
	       $currYear = str_split(date('Y'));
	       $currYear = $currYear[0].$currYear[1].'0'.'0';
	       $year += $currYear;
	    }
	    $dtcredito[2] = $year;
	    $dtcredito = $dtcredito[0].'/'.$dtcredito[1].'/'.$dtcredito[2];
	    
        if ($nsu == NULL && isset($cdlotevenda)) {
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU IS NULL AND NRAUTORIZACAO IS NULL AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA AND CDLOTEVENDA = :CDLOTEVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $cdlotevenda);
            
        } else if (isset($nsu) && $cdlotevenda == NULL && $autorizacao == NULL){
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU = :CDNSU AND NRAUTORIZACAO IS NULL AND CDLOTEVENDA IS NULL AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDNSU', $nsu);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);

        } else if ($nsu == NULL && isset($autorizacao)) {
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU IS NULL AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA AND CDLOTEVENDA = :CDLOTEVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $cdlotevenda);
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
            
        } else{
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU = :CDNSU AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDNSU', $nsu);
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
        }
		oci_bind_by_name($statement, ':DTCREDITO', $dtcredito);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return intval(oci_fetch_assoc($statement)["LINHAS"]) == 0 ? true : false;
    }
    
    private static function conciliacao ($conn, $estabelecimento, $dtIni, $dtFim) {
        $sql = "BEGIN CONCILIACAO_CNC (:P_NRESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
        $statement = oci_parse($conn, $sql);
        
        $P_DTINICIAL = self::$periodIni;
        $P_DTFINAL = self::$periodEnd;
        
        oci_bind_by_name($statement, ':P_NRESTABELEC', $estabelecimento);
        oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
        oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return $bool;
    }
    
    private static function geraFinanceiro ($conn, $estabelecimento) {
        $sql = "BEGIN GERA_FINANCEIRO_CNC(:P_ESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
        $statement = oci_parse($conn, $sql);
        $P_DTINICIAL = self::$periodIni;
        $P_DTFINAL = self::$periodEnd;
        oci_bind_by_name($statement, ':P_ESTABELEC', $estabelecimento);
        oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
        oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return $bool;
    }
}

class AccessInfoInterface {

    protected $idEmpresa;
    protected $pass;
    
    public function __construct($idEmpresa, $pass) {
        $this->idEmpresa = $idEmpresa;
        $this->pass = $pass;
    }
    
    public function getIdEmpresa() {
        return $this->idEmpresa;
    }
        
    public function setIdEmpresa($idEmpresa) {
        $this->idEmpresa = $idEmpresa;
    }
    
    public function getPass() {
        return $this->pass;
    }
        
    public function setPass($pass) {
        $this->pass = $pass;
    }

}

// Chama o metódo principal da classe para executar o WS
Cnc_Equals::executeWSEquals();